# store_critical_data_example

Demonstrates how to use the store_critical_data plugin.

A Flutter plugin to store data in secure storage:
* [Keychain](https://developer.apple.com/library/content/documentation/Security/Conceptual/keychainServConcepts/01introduction/introduction.html#//apple_ref/doc/uid/TP30000897-CH203-TP1) is used for iOS
* AES encryption is used for Android. AES secret key is encrypted with RSA and RSA key is stored in [KeyStore](https://developer.android.com/training/articles/keystore.html)

*Note* KeyStore was introduced in Android 4.3 (API level 18). The plugin wouldn't work for earlier versions.

## Getting Started
```dart
import 'package:store_critical_data/store_critical_data.dart';

// Create storage
final _storage = new ImpigerSecurestroage();

// Write String value
_storage.writeString(key: “key”, value: “value”);

// Read String value
String value = _storage.readString(key: "key");

// Write Double value
_storage.writeDouble(key: “key”, value: “value”);

// Read Double value
final double value = _storage.readDoubleNew(key: "key");


```
