import Flutter
import UIKit
import Security
import Foundation

// Constant Identifiers
let userAccount = "AuthenticatedUser"

// Arguments for the keychain queries
let kSecClassValue = NSString(format: kSecClass)
let kSecAttrAccountValue = NSString(format: kSecAttrAccount)
let kSecValueDataValue = NSString(format: kSecValueData)
let kSecClassGenericPasswordValue = NSString(format: kSecClassGenericPassword)
let kSecAttrServiceValue = NSString(format: kSecAttrService)
let kSecMatchLimitValue = NSString(format: kSecMatchLimit)
let kSecReturnDataValue = NSString(format: kSecReturnData)
let kSecMatchLimitOneValue = NSString(format: kSecMatchLimitOne)

public class SwiftImpigerSecurestroagePlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "impiger_securestroage", binaryMessenger: registrar.messenger())
    let instance = SwiftImpigerSecurestroagePlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

   public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {

   if (call.method == "write_string") {

              let arguments =  call.arguments
              let params = arguments as?[String: Any]
              if params != nil
              {
                  let stringValue = params?["value"] as? String
                  if let key = params?["key"] as? String
                  {
                      self.saveStringValue(key: key, value: stringValue ?? "")
                  }
                  print(params as Any)
              }
          }else if (call.method == "write_boolean"){

              let arguments =  call.arguments
              let params = arguments as?[String: Any]
              if params != nil
              {
                  let boolValue = params?["value"] as? Bool
                  if let key = params?["key"] as? String
                  {
                      self.saveBoolenValue(key: key, isBool: boolValue ?? false)
                  }
              }
          }
          else if (call.method == "write_int"){

              let arguments =  call.arguments
              let params = arguments as?[String: Any]
              if params != nil
              {
                  let intValue = params?["value"] as? Int
                  if let key = params?["key"] as? String
                  {
                      self.saveIntValue(key: key, values: intValue ?? 0)
                  }
              }
          }
          else if (call.method == "write_double"){

              let arguments =  call.arguments
              let params = arguments as?[String: Any]
              if params != nil
              {
                  let doubleValue = params?["value"] as? Double
                  if let key = params?["key"] as? String
                  {
                      self.saveDobleValue(key: key, values: doubleValue ?? 00)
                  }
              }
          }
          else if (call.method == "read_string"){

              let arguments =  call.arguments
              let params = arguments as?[String: Any]
              if params != nil
              {
                  if let key = params?["key"] as? String
                  {
                     self.loadStringValue(key: key, result: result)
                  }
              }

          }
          else if (call.method == "read_boolean"){
              let arguments =  call.arguments
              let params = arguments as?[String: Any]
              if params != nil
              {
                  if let key = params?["key"] as? String
                  {
                     self.loadBoolenValue(key: key, result: result)
                  }
              }
          }
          else if (call.method == "read_int"){
              let arguments =  call.arguments
              let params = arguments as?[String: Any]
              if params != nil
              {
                  if let key = params?["key"] as? String
                  {
                      self.loadIntValue(key: key, result: result)
                  }
              }
          }
          else if (call.method == "read_double"){

              let arguments =  call.arguments
              let params = arguments as?[String: Any]
              if params != nil
              {
                  if let key = params?["key"] as? String
                  {
                      self.loadDobleValue(key: key, result: result)
                  }
              }
          }else if (call.method == "getPlatformVersion")
          {
               result("iOS " + UIDevice.current.systemVersion)
          }
       print(call.method)

      //result("iOS aa " + UIDevice.current.systemVersion)
    }

    func saveStringValue(key: String, value: String) {

            let dataFromString: NSData = value.data(using: String.Encoding.utf8, allowLossyConversion: false)! as NSData
            self.saveToKeyChain(key: key, dataFrom: dataFromString)
        }
        func saveBoolenValue(key: String, isBool: Bool) {

            let boolAsString = String(isBool)
            let dataFromString: NSData = boolAsString.data(using: String.Encoding.utf8, allowLossyConversion: false)! as NSData
            self.saveToKeyChain(key: key, dataFrom: dataFromString as NSData)
        }

        func saveDobleValue(key: String, values: Double)
        {
            let doubleValues = "\(values)"
            let dataFromString: NSData = doubleValues.data(using: String.Encoding.utf8, allowLossyConversion: false)! as NSData
            self.saveToKeyChain(key: key, dataFrom: dataFromString as NSData)

        }
        func saveIntValue(key: String, values: Int)
        {
               let doubleValues = "\(values)"
               let dataFromString: NSData = doubleValues.data(using: String.Encoding.utf8, allowLossyConversion: false)! as NSData
               self.saveToKeyChain(key: key, dataFrom: dataFromString as NSData)
        }

          func loadStringValue(key: String, result: FlutterResult) {

           if let stringValue = self.load(service: key as NSString)
           {
               result(stringValue)
            }
          }
          func loadBoolenValue(key: String, result: FlutterResult) {

             if let stringValue = self.load(service: key as NSString)
             {
                let boolValue = stringValue.boolValue
                result(boolValue)
            }
          }

          func loadDobleValue(key: String, result: FlutterResult)
          {
            if let stringValue = self.load(service: key as NSString)
            {
                let doubleValue = stringValue.doubleValue
                result(doubleValue)
            }

          }
          func loadIntValue(key: String, result: FlutterResult)
          {
                if let stringValue = self.load(service: key as NSString)
                {
                    let intValue = stringValue.intValue
                    result(intValue)
            }
          }



        func saveToKeyChain(key : String, dataFrom: NSData)
        {
            // Instantiate a new default keychain query
            let keychainQuery: NSMutableDictionary = NSMutableDictionary(objects: [kSecClassGenericPasswordValue, key, userAccount, dataFrom], forKeys: [kSecClassValue, kSecAttrServiceValue, kSecAttrAccountValue, kSecValueDataValue])

            // Delete any existing items
            SecItemDelete(keychainQuery as CFDictionary)

            // Add the new keychain item
            SecItemAdd(keychainQuery as CFDictionary, nil)
        }


          func load(service: NSString) -> NSString? {
             // Instantiate a new default keychain query
             // Tell the query to return a result
             // Limit our results to one item
            let keychainQuery: NSMutableDictionary = NSMutableDictionary(objects: [kSecClassGenericPasswordValue, service, userAccount, kCFBooleanTrue!, kSecMatchLimitOneValue], forKeys: [kSecClassValue, kSecAttrServiceValue, kSecAttrAccountValue, kSecReturnDataValue, kSecMatchLimitValue])

             var dataTypeRef :AnyObject?

             // Search for the keychain items
             let status: OSStatus = SecItemCopyMatching(keychainQuery, &dataTypeRef)
             var contentsOfKeychain: NSString? = nil

             if status == errSecSuccess {
                 if let retrievedData = dataTypeRef as? NSData {
                    contentsOfKeychain = NSString(data: retrievedData as Data, encoding: String.Encoding.utf8.rawValue)
                 }
             } else {
                 print("Nothing was retrieved from the keychain. Status code \(status)")
             }

             return contentsOfKeychain
         }
  }




